> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List workbook controls

GET https://api.sigmacomputing.com/v2/workbooks/{workbookId}/controls

This endpoint retrieves all controls associated with a specific workbook. Controls are interactive elements like checkboxes, or dropdowns used within the workbook for dynamic data interaction.

### Usage notes
- Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.

### Usage scenarios
- **Dynamic data interaction:** Allows users to interact dynamically with the data presented in the workbook through various control mechanisms.
- **Custom reporting:** Enables the creation of customizable reports where end users can adjust parameters to filter and sort data according to their requirements.

### Best practices
- Ensure proper access controls are set to manage who can view or interact with the controls to prevent unauthorized data manipulation.
- Use detailed and descriptive names for controls to facilitate easier identification and use by end users.

Reference: https://help.sigmacomputing.com/reference/get-workbook-controls

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/controls:
    get:
      operationId: getWorkbookControls
      summary: List workbook controls
      description: >-
        This endpoint retrieves all controls associated with a specific
        workbook. Controls are interactive elements like checkboxes, or
        dropdowns used within the workbook for dynamic data interaction.


        ### Usage notes

        - Retrieve the **workbookId** by calling the
        [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks)
        endpoint.


        ### Usage scenarios

        - **Dynamic data interaction:** Allows users to interact dynamically
        with the data presented in the workbook through various control
        mechanisms.

        - **Custom reporting:** Enables the creation of customizable reports
        where end users can adjust parameters to filter and sort data according
        to their requirements.


        ### Best practices

        - Ensure proper access controls are set to manage who can view or
        interact with the controls to prevent unauthorized data manipulation.

        - Use detailed and descriptive names for controls to facilitate easier
        identification and use by end users.
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/workbooks_getWorkbookControls_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0:
      type: string
      enum:
        - boolean
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1:
      type: string
      enum:
        - number
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2:
      type: string
      enum:
        - text
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3:
      type: string
      enum:
        - date
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4:
      type: string
      enum:
        - number-list
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5:
      type: string
      enum:
        - text-list
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6:
      type: string
      enum:
        - date-list
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7:
      type: string
      enum:
        - boolean-list
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8:
      type: string
      enum:
        - date-range
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9:
      type: string
      enum:
        - number-range
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10:
      type: string
      enum:
        - date-null
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11:
      type: string
      enum:
        - number-null
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12:
      type: string
      enum:
        - text-null
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13:
      type: string
      enum:
        - boolean-null
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType:
      oneOf:
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType0
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType1
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType2
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType3
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType4
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType5
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType6
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType7
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType8
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType9
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType10
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType11
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType12
        - $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType13
      description: Value of the control
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType
    V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems:
      type: object
      properties:
        name:
          type: string
        valueType:
          $ref: >-
            #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItemsValueType
          description: Value of the control
      required:
        - name
        - valueType
      title: >-
        V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems
    workbooks_getWorkbookControls_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2WorkbooksWorkbookIdControlsGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: workbooks_getWorkbookControls_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "entries": [
    {
      "name": "Show Active Customers",
      "valueType": "boolean"
    },
    {
      "name": "Region Filter",
      "valueType": "text-list"
    },
    {
      "name": "Sales Date Range",
      "valueType": "date-range"
    },
    {
      "name": "Minimum Order Quantity",
      "valueType": "number-range"
    }
  ],
  "nextPage": null,
  "total": 4
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/controls"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/controls';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/controls"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/controls")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/workbooks/workbookId/controls")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/controls', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/controls");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/controls")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```